<template>
  <q-page class="q-pa-lg">
    
    <q-btn :to="{ name: 'home' }" flat class="q-pa-none">
      <q-icon name="arrow_back" size="sm" />
    </q-btn>

    <h1 v-if="times.length > 1">{{ community }} Celebrations</h1>
    <h1 v-else>{{ community }} Celebration</h1>
    
    <q-list bordered separator>
      <q-item
        v-for="time in times"
        :key="time.id"
        clickable
        :to="{ name: 'time', params: { idCommunity: idCommunity, idTime: time.id }}"
        style="min-height: 100px;"
      >
        <q-item-section>
          <q-item-label>
            <p class="text-h3 q-mb-none">{{ time.label }} Uhr</p>
          </q-item-label>
        </q-item-section>
      </q-item>
    </q-list>

    <div class="q-mt-xl full-width">
      <q-btn flat class="q-pl-sm" v-if="isAdmin" :to="{ name: 'statsCommunity', params: { idCommunity: idCommunity } }">Statistiken</q-btn>
    </div>
    
  </q-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import { mapGetters } from "vuex";
import { getDatabase, ref as refFb, onValue } from "firebase/database";

export default defineComponent({
  name: "PageTime",
  props: {
    idCommunity: {
      required: true,
    },
  },
  computed: {
    ...mapGetters({
      user: "counter/getUser",
      isAdmin: "counter/isAdmin",
    }),
  },
  setup() {
    let community = ref("");
    let times = ref([]);

    return {
      community,
      times,
    };
  },
  mounted() {
    this.loadCommunity(this.idCommunity);
  },
  async beforeRouteUpdate(to, from) {
    this.loadCommunity(to.params.idCommunity);
  },
  methods: {
    loadCommunity(id) {

      const db = getDatabase();
      
      const starCountRef = refFb(db, "communities/" + id);
      onValue(starCountRef, (snapshot) => {

        const data = snapshot.val();
        
        this.times = [];
        this.community = data.label;
        
        Object.keys(data.times).forEach((entry) => {
          this.times.push({ id: entry, label: data.times[entry].label });
        });

        this.times.sort((a, b) => a.id > b.id ? 1 : -1);
      });

    },
  },
});
</script>
